/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#pragma ident	"%Z%%M%	%I%	%E% SMI"

#pragma D depends_on module unix

typedef struct syseventinfo {
	string	se_class;		/* event class */
	string	se_subclass;		/* event subclass */
	string	se_publisher;		/* event publisher */
} syseventinfo_t;

#pragma D binding "1.0" translator
translator syseventinfo_t < sysevent_impl_t *ev > {
	se_class = stringof(((char*)&(((sysevent_impl_t*)(void*)(ev))->se_class_name)));
	se_subclass = stringof(((char*)((caddr_t)(ev)+(((sysevent_impl_t*)(void*)(ev))->se_header.se_subclass_off))));
	se_publisher = stringof(((char*)((caddr_t)(ev)+(((sysevent_impl_t*)(void*)(ev))->se_header.se_pub_off))));
};

typedef struct syseventchaninfo {
	string	ec_name;		/* channel name, or NULL if default */
} syseventchaninfo_t;

#pragma D binding "1.0" translator
translator syseventchaninfo_t < evch_bind_t *bind > {
	ec_name = (bind ? stringof(bind->bd_channel->ch_name) : NULL);
};
